function obr = vykresliTrojuhelnik(bod1, bod2, bod3, obr)
%obr = vykresliTrojuhelnik(bod1, bod2, bod3, obr)
%funkce pro vykresleni trojuhelniku, ktery ma barvu odpovidajici plynulemu
%prechodu mezi barvami vrcholu.
%bod1, bod2, bod3...souradnice vrcholu trojuhelniku:
%   bod = [u;v;H],
%   ,kde u,v...jsou souradnice bodu v obrazku
%          H...je barevny odstin bodu
%obr = matice borazovych dat, ktere se potom pouziji pro tvorbu obrazku

        CP(1:3,1) = bod1;
        CP(1:3,2) = bod2;
        CP(1:3,3) = bod3;
        tri = delaunay((CP(1,:))',(CP(2,:))');
        j= 1;
        poradi = serad(CP(2,tri(j,1)),CP(2,tri(j,2)),CP(2,tri(j,3)));
        AB = Line(round(CP(:,tri(j,poradi(1)))),round(CP(:,tri(j,poradi(2)))));
        CB = Line(round(CP(:,tri(j,poradi(3)))),round(CP(:,tri(j,poradi(2)))));
        AC = Line(round(CP(:,tri(j,poradi(1)))),round(CP(:,tri(j,poradi(3)))));
        obr = DrawLine(round(CP(:,tri(j,poradi(1)))),round(CP(:,tri(j,poradi(2)))),obr);
        obr = DrawLine(round(CP(:,tri(j,poradi(3)))),round(CP(:,tri(j,poradi(2)))),obr);
        obr = DrawLine(round(CP(:,tri(j,poradi(1)))),round(CP(:,tri(j,poradi(3)))),obr);
        sizeAB = size(AB);
        sizeCB = size(CB);
        sizeAC = size(AC);
        
        %uprava smeru:
        pom = ones(3,1);
        if(AB(1,1)>AB(1,sizeAB(2)))
            for ic = sizeAB(2):-1:1
                pom(:,sizeAB(2)-ic+1) = AB(:,ic);
            end
            AB = pom;
        end
        pom = ones(3,1);
        if(CB(1,1)<CB(1,sizeCB(2)))
            for ic = sizeCB(2):-1:1
                pom(:,sizeCB(2)-ic+1) = CB(:,ic);
            end
            CB = pom;
        end
        pom = ones(3,1);
        if(AC(1,1)>AC(1,sizeAC(2)))
            for ic = sizeAC(2):-1:1
                pom(:,sizeAC(2)-ic+1) = AC(:,ic);
            end
            AC = pom;
        end
        
        %bod B vlevo / vpravo:
        Bvlevo = 0;
        for ic = 1:sizeAC
            if(CP(2,tri(j,poradi(2))) < AC(2,ic))
                Bvlevo = 1;
            else Bvlevo = 0;
            end
        end

        %souradnice usecek:
        AB_ = ones(3,1);
            AB_(:,1) = AB(:,1);
            i_ = 1;
            for ic = 1:sizeAB(2)
                if(AB(1,ic)>AB_(1,i_))
                    i_ = i_ + 1;
                    AB_(:,i_) = AB(:,ic);
                end
        end
        
        CB_ = ones(3,1);
            CB_(:,1) = CB(:,1);
            i_ = 1;
            for ic = 1:sizeCB(2)
                if(CB(1,ic)<CB_(1,i_))
                    i_ = i_ + 1;
                    CB_(:,i_) = CB(:,ic);
                end
            end
        
        AC_ = ones(3,1);
        AC_(:,1) = AC(:,1);
        i_ = 1;
        for ic = 1:sizeAC(2)
            if(AC(1,ic)>AC_(1,i_))
                i_ = i_ + 1;
                AC_(:,i_) = AC(:,ic);
            end
            if((AC(2,ic)>AC_(2,i_))&&(Bvlevo))
                AC_(:,i_) = AC(:,ic);
            end
            if((AC(2,ic)<AC_(2,i_))&&(~Bvlevo))
                AC_(:,i_) = AC(:,ic);
            end
            
        end

        sizeAB_ = size(AB_);
        sizeCB_ = size(CB_);
        sizeAC_ = size(AC_);
        for ii = 1:sizeCB_(2)
            p1 = AC_(:,ii);
            p2 = CB_(:,sizeCB_(2)-ii+1);
            obr = DrawLine([AC_(2,ii);AC_(1,ii);AC_(3,ii)],[CB_(2,sizeCB_(2)-ii+1);CB_(1,sizeCB_(2)-ii+1);CB_(3,sizeCB_(2)-ii+1)],obr);
        end
        
        for ii = 1:sizeAB_(2)
            p3 = AB_(:,ii);
            p4 = AC_(:,(sizeAC_(2)-sizeAB_(2)+ii));
            obr = DrawLine([AB_(2,ii);AB_(1,ii);AB_(3,ii)],[AC_(2,sizeAC_(2)-sizeAB_(2)+ii);AC_(1,sizeAC_(2)-sizeAB_(2)+ii);AC_(3,sizeAC_(2)-sizeAB_(2)+ii)],obr);
        end
